Attribute VB_Name = "Module1"
'/////////////////////////////////////////////////////////////////////////////
'// MakeGUID - A small, demo VBToolbox CGI app to make a unique GUID string
'// Copyright (C) M Shaw - 2008 - Freeware - No Warranties
'// Website: http://vbtoolbox.kerys.co.uk
'/////////////////////////////////////////////////////////////////////////////
'// Versions:
'// 1.00 14/Jul/2008 First version
'// 1.01 --/Jul/2008 Added system event logging
'// 1.02 31/Aug/2009 Recompiled for DLL v1.21
'// 1.03 23/Jul/2010 Recompiled for new URLs

'/////////////////////////////////////////////////////////////////////////////

'------------------------------------------------------------------------------
'IMPORTANT: *Optional* steps after compiling to convert to full console mode
'------------------------------------------------------------------------------
'When compiled, this program will allocate a new console window and
'will not capture I/O from any current CMD console window I/O (C:\> prompt)
'You can change this program to a native console application by re-linking it
'Download the updated Microsoft LINK.EXE v5.12.8078 included with MASM32 9.0
'from http://www.masm32.com/masmdl.htm
'Once installed use the following command convert to a normal console app
'C:\MASM32\bin\LINK.EXE /EDIT /SUBSYSTEM:CONSOLE vbcgi.exe
'(LINK.EXE supplied with VB 5 (v4.20) will NOT work - you need v5.12+)
'Please note that this conversion is and OPTIONAL but recommended step
'------------------------------------------------------------------------------
'If launched from the VB IDE note that you will see BRIEF (<500msecs) output!
'------------------------------------------------------------------------------
Option Explicit

Public Declare Function LibVersion Lib "mslib145.dll" () As Long
Public Declare Function OpenConsole Lib "mslib145" () As Long
Public Declare Function ConsoleOpen Lib "mslib145" () As Integer
Public Declare Sub CloseConsole Lib "mslib145" ()
Public Declare Function WriteLn Lib "mslib145" (Optional ByVal s As String = "") As Long
'We can use WriteLn as a command to write a lone CRLF newline
Public Declare Function Writes Lib "mslib145" (ByVal s As String) As Long
Public Declare Function CreateGUID Lib "mslib145.dll" (Optional ByVal Formatted As Boolean = True) As String
Public Declare Function LogEvent Lib "mslib145.dll" (ByVal AppName As String, ByVal Message As String, _
        ByVal LogType As Integer, Optional ByVal EventID As Long = 0) As Boolean
        
Public Const EVENTLOG_ERROR_TYPE = 1

Public Const AUTHOR = "M Shaw"
Public Const VERSION As Long = 118        ' This release needs this version or higher VBToolbox DLL
Public Const VERDATE = "23rd July 2010"
Public Const WEBSITE = "http://vbtoolbox.kerys.co.uk"
Public Const EXENAME = "MakeGUID"
Public ERL As Integer

Sub Main()
    Dim s As String
    Dim LF As String
    Dim Q As String
    On Error GoTo Error
    
    LF = Chr$(10)   ' New-line "\n", 0x0a
    Q = Chr$(34)    ' Quote char
    
    ERL = 10
    If IsDLLInstalled() Then
        ' No VBToolbox functions other than LibVersion() may be called within this error-handler
        If LibVersion() < VERSION Then
            '//////////////////////////////////////////////////////////////////////////////////////////////////////
            ' * NEVER * use msgbox() etc. in production code!! (this code for demo use only)
            ' System errors and other problems should be logged to file and need no human interaction
            'MsgBox "Wrong DLL version for this test program version v" & Format$(LibVersion() / 100#) & " found" & vbCrLf & "I want version v" & format$(Val(VERSION) / 100), vbCritical, "Outdated MSLIB145.DLL found"
            '/////////////////////////////////////////////////////////////////////////////////////////////////////
            App.LogEvent "Wrong DLL version for this test program version v" & Format$(LibVersion() / 100#) & " found" & vbCrLf & " version" & Format$(Val(VERSION) / 100) & " expected", vbLogEventTypeError
            End
        End If
    Else
        ERL = 20
        '//////////////////////////////////////////////////////////////////////////////////////////////////////////
        ' * NEVER * use msgbox() etc. in production code!! (this code for demo use only)
        'MsgBox "DLL MSLIB145.DLL is not installed or in the PATH", vbCritical, "Required MSLIB145.DLL not found"
        '//////////////////////////////////////////////////////////////////////////////////////////////////////////
        App.LogEvent "Required DLL MSLIB145.DLL is not installed or in the current PATH - Exiting", vbLogEventTypeError
        End     ' CGI needs to end quietly and log any problems to file
    End If
    
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////
    
    ERL = 30
    OpenConsole
    If ConsoleOpen() Then
        s = CreateGUID()
        ERL = 40
        WriteHTTPHeader
        WriteLn "<html><head>"
        WriteLn "<meta name=" & Q & "GENERATOR" & Q & " content=" & Q & "VBToolbox.CreateGUID 1.0" & Q & ">"
        WriteLn "</head><body bgcolor=" & Q & "#FFFFB3" & Q & ">"
        WriteLn "<center><h1>"
        If s <> "" Then
            WriteLn "Your unique GUID is: " & s
        Else
            WriteLn "Error: Sorry but something awful happened and I couldn't generate a GUID - try again"
        End If
        WriteLn "</h1></center>"
        WriteLn "<center>Refresh this page to generate another one</center>"
        WriteLn "<br><center><a href=" & Q & WEBSITE & Q & ">" & WEBSITE & "</a></center>"
        WriteLn "</head></body></html>"
    End If
    ERL = 50
    CloseConsole
Exit Sub
    
Error:
    'Enable for debugging outside of the CGI environment only
    'NEVER require user-input for production CGI code - always log problems to file
    'MsgBox "Error " & Format$(Err.Number) & " (" & Err.Description & ") at line " & Format$(Erl)
    Debug.Print "Error " & Format$(Err.Number) & " (" & Err.Description & ") at line " & Format$(ERL)
    'Alternative Error Logging
    'LogEvent EXENAME, "Error " & Format$(Err.Number) & " (" & Err.Description & ") at line " & Format$(ERL), EVENTLOG_ERROR_TYPE, 1
    App.LogEvent "Error " & Format$(Err.Number) & " (" & Err.Description & ") at line " & Format$(ERL), vbLogEventTypeError
    Resume Next
End Sub

Public Sub WriteHTTPHeader()
    'WriteLn "HTTP/1.0 200 OK" & vbCrLf ' May be required in Abyss or other servers
    WriteLn "Content-Type: text/html" & Chr$(10) & Chr$(10)
End Sub
Public Function IsDLLInstalled() As Boolean
    Dim r As Long
    IsDLLInstalled = True
    On Error GoTo NoDll
    r = LibVersion()           'This is common to all versions (was _libversion Alias)
    On Error GoTo 0
    Exit Function

NoDll:
    IsDLLInstalled = False
    Debug.Print "Error "; Err.Number; " - "; Err.Description; ") in IsDLLInstalled"
    Resume Next
End Function
'//////////////////////////////////// EOF /////////////////////////////////////////
