Attribute VB_Name = "mMSLib145"
'==================================================================================================
' MSLIB145.BAS  - Copyright (C) M Shaw - Nov 2003..July 2010
'==================================================================================================
' Purpose: VB 5 and above declares to link to MSLIB145.DLL
'==================================================================================================
' Copyright (C) M Shaw - 2003-2010 - Freeware - NO WARRANTY - NO SUPPORT
' See website and any accompanying README.TXT for conditions of use
' http://vbtoolbox.kerys.co.uk
'
' Comment-out, uncomment, or copy sections of this file to your project as required
' You may freely rename declared functions using aliases if required
'
' Latest version was tested OK on Windows NT4.0(SP6a), Windows 2000 (SP4), Windows XP(SP2)
' Console/CGI functions tested on the above and OK
' NB: GetAvailableVirtualMemory and GetTotalVirtualMemory API calls do not work on NT 4.0
' This file may contain developer-only test routines at the end of the file which may be ignored
'==================================================================================================
' * WARNING * DO NOT UPX-PACK/REPACK the DLL if you use the LogEvent() functions!
' * Repack using: upx -9 --keep-resource=11/1 mslib145.dll
'==================================================================================================

'Updates:

'V1.00 23/11/2003 First version with very "basic" functions
'V1.01 15/04/2005 Updated version with encryption (code was lost c2006)
'V1.02 01/06/2008 Lost DLL C code partially reconstructed
'V1.03 02/06/2008 NumOrd, Mk*/Cv*, Windows version routines etc.
'v1.04 03/06/2008 Disk space API functs etc. Readfile fixed
'v1.05 04/06/2008 Added IP functs IPMatch, MatchCIDR, IPToLong etc.
'v1.06 05/06/2008 Added Windows mem API functs
'v1.07 15/06/2008 PHPDate added with basic functionality
'V1.08 18/06/2008 PHPDate expanded - PHPDateNow DSTAdjust
'                 vbdate_to_time WinSleep Fraction/Integral etc.
'V1.09 21/06/2008 Round HexToDate/DateToHex
'V1.10 22/06/2008 Code-review - attempt to reduce garbage passed after 0x00 in strings
'                  BitPack , BitUnPack, PiStrm, fixed DST bug using mktime() evaluating elmination
'                  of need for vbStr() by using byte allocation API calls (means no future Unicode)
'v1.11 25/06/2008 Bugfixes. Conditional Unicode compile (off). String (esp NULL) returns examined
'                 Need for vbStr() eliminated
'V1.12 26/06/2008 EncodeStr64 byte len - API allocates for NULL terminator (excess removed)
'                 Bugfix BinToDec() for mixed binary/alpha chars postfix
'V1.13 28/06/2008 StripX... functions changed to return a new API-allocated string via function return
'                 Note documentation re: conversion of console apps to full-console mode using LINK.EXE
'v1.14 31/06/2008 Removed InNewConsole(), Replaced with InNativeConsole()
'v1.15 05/07/2008 SetConsoleAttributes,ClearConsoleAttributes, InKey, Colour constant, WhereX/Y, GotoXY
'                 FileType, WriteLn (Changed), Writes, GetOpenFile, GetSave File (ready), GetArgs
'                 Tokenise,
'v1.16 --/07/2008 RotateByte, RotateInt, RotateLong
'v1.17 10/07/2008 HexToLong, HexToDouble, ListFiles, FilesMatch, WildcardMatch, ShellRun
'v1.18 14/07/2008 BaseConvDouble, MapNetworkDrive, MapNextFreeNetworkDrive, UnMapDrive, GetCGIArgs, DriveType
'                 IsHardDisk, IsRAMDisk, IsCDROMDisk, IsNetworkDisk, IsRemovableDisk, Variant memory
'                 allocation rewritten
'v1.19 19/07/2008 CreateGUID, LogEvent, AddEventSource, RemoveEventSource, GetDLLFileName
'                 IsEventSource, ReadDWORDFromRegistry, WriteDWORDToRegistry, WriteStringToRegistry
'v1.20 20/07/2009 Additional time traces for Windows 7 testing (found to be 10x slower than XP!)
'v1.21 24/08/2009 This version is a major revision
'                 Renamed IsDLLInstalled to IsVBToolboxDLLInstalled. Change encryptstring len from int to long
'                 added MapiSend(). Changed name of VERSION control Const to DLL_VERSION.
'                 Traced memory leak in VB to returned string - thus changed EncryptString from Function to a Sub
'                 Enhanced EncryptString() - new parameter ExtraSecure. New Length parameter for StrToHex to
'                 accurately-control processing of strings with embedded nulls as produced by EncrytString()
'                 Added new simple function: StringToHex() to supplement complex function StrToHex()
'                 Internal structure of many functions which return strings has been restructured to eliminate
'                 memory leaks. The test-program was changed to enable longer-term tests including the tracking
'                 of memory-allocation using Windows task-manager.
'V1.22 03/09/2009 Improved MAPISendMessage() Added GetProcessMemoryUsed(). PiStr() removed ready to migrate to
'                 a separate DLL (pi.dll)
'v1.23 09/09/2009 Revised encryption method for EncryptString() now with added Salt
'v1.24 11/09/2009 Fix bitshift bug in Bin8, Bin16, Bin32
'                 Implement RLECompress/RLEDecompress, RLECompressedByteCount, RLEDecompressedByteCount
'1.25 15/09/2009  Added mt_rnd() code, MTRnd(), MTRandomStr(), MTRandomise(). MTRndDouble()
'                 StringToBMP(), BMPToString(). Fix strlen() bug with binary strings in RandomStr()
'                 Ceil(), Floor(). Bugfix in RandomStringBinaryString*
'                 RLEByteCount, RLECompressedByteCount, RLEUncompressedByteCount
'1.26 21/06/2010  RLECompressible. Complete unfinished work from v1.25. StrSplit(), Tokenise() and Strsplit()
'                 now use dynamically-allocated heap memory rather than fixed limits
'1.27 03/07/2010  BGRSplit, BGRtoRGB and BMPDataSize added
'1.28 20/07/2010  WipeFile, GetUserDir and GetProfileDir added
'1.29 22/07/2010  Changed URL and embedded banner graphic in test project to match

' //////////////////////////////////////////////////////////////////////////////////////////////////////

Option Base 0               ' Arrays are based at 0 (change if required - not recommended)
Option Explicit             ' Vars must be declared

#Const VB5 = True           'Comment-out this line for VB6

Public Const VERNUM As String = "1.29"              ' This test app's release version
Public Const DLL_VERSION As String = "1.29"         ' This VB code release ID is required (to match DLL version)
Public Const WEBSITE As String = "http://vbtoolbox.kerys.co.uk"
Public Const DLLNAME As String = "mslib145.dll"     'Can't use this Const in Declares unfortunately
Public Const DLLDATE As String = "20100722"

Public Const HKEY_CLASSES_ROOT = &H80000000
'Public Const HKEY_LOCAL_USER = &H80000001  ' Alternate HKCU
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_CURRENT_CONFIG = &H80000005

' RandomStr()
Public Const RandomStringMixedCase = 0
Public Const RandomStringLower = 1
Public Const RandomStringUpper = 2
Public Const RandomStringNumeric = 3
Public Const RandomStringAll = 4
Public Const RandomStringBinary = 5
Public Const RandomStringHex = 6        ' // v1.21+ // New
Public Const RandomStringBinaryString = 7
Public Const RandomStringBinaryStringBias0 = 8
Public Const RandomStringBinaryStringBias1 = 9

' For LogEvent()
Public Const EVENTLOG_SUCCESS = 0
Public Const EVENTLOG_ERROR_TYPE = 1
Public Const EVENTLOG_WARNING_TYPE = 2
Public Const EVENTLOG_INFORMATION_TYPE = 4
Public Const EVENTLOG_AUDIT_SUCCESS = 8
Public Const EVENTLOG_AUDIT_FAILURE = 10

' DLL management
Public Declare Function LibVersion Lib "mslib145.dll" () As Long

' Graphics functions
Public Declare Function StringToBMP Lib "mslib145" (ByVal s As String, ByVal Size As Long, ByRef BMPSize As Long, _
    Optional ByVal ForeColour As Long = 0, Optional ByVal BackColour As Long = &HFFFFFF) As String
Public Declare Function BMPToString Lib "mslib145" (ByVal BMPData As String, Optional ByRef DataSize As Long = 0) As String
Public Declare Function JPEGHeader Lib "mslib145.dll" (ByVal Filename As String, _
    Width As Integer, Height As Integer, FileLength As Long) As Boolean
Public Declare Function JPEGCheck Lib "mslib145.dll" (ByVal Filename As String) As Boolean

Public Declare Function BMPDataSize Lib "mslib145" (ByVal BMPData As String) As Long
Public Declare Function BMPInfo Lib "mslib145" (ByVal BMPData As String, _
    Optional ByRef Width As Long, Optional ByRef Height As Long, _
    Optional ByRef SizeBytes As Long, Optional ByRef Bpp As Long) As Boolean
Public Declare Sub BGRSplit Lib "mslib145" (ByVal BGRValue As Long, ByRef Red As Integer, ByRef Green As Integer, ByRef Blue As Integer)
Public Declare Function BGRToRGB Lib "mslib145" (ByVal BGRValue As Long) As Long

' String functions
Public Declare Function WildcardMatch Lib "mslib145.dll" (ByVal s As String, _
    ByVal Wildcard As String, Optional IgnoreCase As Boolean = False) As Boolean
Public Declare Function Tokenise Lib "mslib145.dll" (ByVal s As String, _
    ByVal Tokens As String, Optional ByVal Base As Integer = 0) As Variant
'VB6 Split function emulated
Public Declare Function StrSplit Lib "mslib145.dll" (ByVal s As String, _
    ByVal Token As String, Optional ByVal Base As Integer = 0, Optional ByVal IgnoreCase As Boolean = False) As Variant

Public Declare Function CommaStr Lib "mslib145.dll" (ByVal s As String, _
    Optional ByVal Decimals As Integer = 0) As String
Public Declare Function Comma Lib "mslib145.dll" (ByVal Value As Double, _
    Optional ByVal Decimals As Integer = 0) As String
Public Declare Function FillString Lib "mslib145.dll" (ByVal s As String, _
    ByVal CharToUse As String) As String
Public Declare Function InStrI Lib "mslib145.dll" (ByVal s As String, ByVal search As String) As Long
Public Declare Function InChrRev Lib "mslib145.dll" (ByVal s As String, ByVal iChar As Integer) As Long
Public Declare Function InChr Lib "mslib145.dll" (ByVal s As String, ByVal iChar As Integer) As Long
Public Declare Function InStrRev Lib "mslib145.dll" (ByVal s As String, ByVal search As String) As Long
Public Declare Function IsAllChar Lib "mslib145.dll" (ByVal s As String, ByVal TheChar As String) As Boolean
Public Declare Function StripLStr Lib "mslib145.dll" (ByVal s As String, ByVal Mask As String) As String
Public Declare Function StripL Lib "mslib145.dll" (ByVal s As String, ByVal Mask As String) As String
Public Declare Function StripRStr Lib "mslib145.dll" (ByVal s As String, ByVal Mask As String) As String
Public Declare Function StripR Lib "mslib145.dll" (ByVal s As String, ByVal Mask As String) As String
Public Declare Function StrRev Lib "mslib145.dll" (ByVal s As String) As String
Public Declare Function SysLen Lib "mslib145.dll" (ByVal s As String) As Long

#If VB5 Then    'Replace() is built-in in VB6
Public Declare Function Replace Lib "mslib145.dll" (ByVal s As String, ByVal a As String, _
    ByVal b As String) As String
#End If

Public Declare Function ReplaceChar Lib "mslib145.dll" (ByVal s As String, _
    ByVal SearchedFor As String, ByVal Replacement As String) As String
Public Declare Function GetArrayDimensions Lib "mslib145.dll" (ByRef V As Variant) As Long

' Data conversion functions
Public Declare Function BaseConv Lib "mslib145.dll" (ByVal Value As Long, _
    ByVal Base As Integer) As String
Public Declare Function BaseConvDouble Lib "mslib145.dll" (ByVal Value As Double, _
    ByVal Base As Integer) As String
Public Declare Function Bin8 Lib "mslib145.dll" (ByVal i As Byte) As String
Public Declare Function Bin16 Lib "mslib145.dll" (ByVal i As Integer) As String
Public Declare Function Bin32 Lib "mslib145.dll" (ByVal i As Long) As String
Public Declare Function BinToDec Lib "mslib145.dll" (ByVal s As String) As Long
Public Declare Function BitPack Lib "mslib145.dll" (ByVal s As String, _
    Optional ByVal length As Long) As String
Public Declare Function BitUnPack Lib "mslib145.dll" (ByVal s As String, _
    Optional ByVal BitPairs As Long) As String
Public Declare Function RotateByte Lib "mslib145.dll" (ByRef b As Byte) As Byte
Public Declare Function RotateInt Lib "mslib145.dll" (ByRef i As Integer) As Integer
Public Declare Function RotateLong Lib "mslib145.dll" (ByRef l As Long) As Long

' Charhex, HexChar, HexInt, HexLong have changed names from V1.07+
Public Declare Function HexToChar Lib "mslib145.dll" (ByVal HexPair As String) As Byte
Public Declare Function HexToInt Lib "mslib145.dll" (ByVal Str As String) As Integer
Public Declare Function HexToLong Lib "mslib145.dll" (ByVal Str As String) As Double
Public Declare Function HexToDouble Lib "mslib145.dll" (ByVal Str As String) As Double
Public Declare Function CharToHex Lib "mslib145.dll" (ByVal b As Integer) As String
Public Declare Function IntToHex Lib "mslib145.dll" (ByVal i As Integer) As String
Public Declare Function LongToHex Lib "mslib145.dll" (ByVal l As Double) As String

Public Declare Function StringToHex Lib "mslib145.dll" (ByVal s As String) As String
Public Declare Function StrToHex Lib "mslib145.dll" (ByVal s As String, _
    ByVal length As Long, Optional ByVal WrapWidth As Integer) As String

Public Declare Function HexToStr Lib "mslib145.dll" (ByVal s As String) As String

Public Declare Function CreateGUID Lib "mslib145.dll" ( _
    Optional ByVal Formatted As Boolean = True) As String

' Legacy BASIC functions
' CV*/MK* Data Conversion - VB data types (byte sizes)
' Byte    1 byte  0 to 255
' Integer     2 bytes -32,768 to 32,767
' Long (long integer)  4 bytes -2,147,483,648 to 2,147,483,647&
' Single (single-precision floating-point)   4 bytes -3.402823E38 to -1.401298E-45 for negative values; 1.401298E-45 to 3.402823E38 for positive values
' Double (double-precision floating-point)   8 bytes -1.79769313486232E308 to
' -4.94065645841247E-324 for negative values; 4.94065645841247E-324 to 1.79769313486232E308 for positive values

Public Declare Function Mki Lib "mslib145.dll" (ByVal i As Integer) As String
Public Declare Function Cvi Lib "mslib145.dll" (ByVal Str As String) As Integer
Public Declare Function Mkl Lib "mslib145.dll" (ByVal l As Long) As String
Public Declare Function Cvl Lib "mslib145.dll" (ByVal Str As String) As Long
Public Declare Function Mkf Lib "mslib145.dll" (ByVal F As Single) As String
Public Declare Function Cvf Lib "mslib145.dll" (ByVal Str As String) As Single
Public Declare Function Mkd Lib "mslib145.dll" (ByVal d As Double) As String
Public Declare Function Cvd Lib "mslib145.dll" (ByVal Str As String) As Double

' Windows API functions
Public Declare Function logevent Lib "mslib145.dll" Alias "LogEvent" (ByVal AppName As _
    String, ByVal Message As String, ByVal LogType As _
    Integer, Optional ByVal PostScript As String = vbNullString) As Boolean
Public Declare Function IsEventSource Lib "mslib145.dll" (ByVal AppName As String) _
    As Boolean
Public Declare Function AddEventSource Lib "mslib145.dll" (ByVal AppName As String, _
    Optional ByVal CategoryCount As Integer = 0) As Boolean
Public Declare Function RemoveEventSource Lib "mslib145.dll" (ByVal AppName As String) _
    As Boolean
Public Declare Function DiskFree Lib "mslib145.dll" (ByVal Drive As String) As Double
Public Declare Function DiskFreeGig Lib "mslib145.dll" (ByVal Drive As String) As Double
Public Declare Function DiskFreeMeg Lib "mslib145.dll" (ByVal Drive As String) As Double
Public Declare Function FileExists Lib "mslib145.dll" (ByVal Filespec As String) As Boolean
Public Declare Function DriveExists Lib "mslib145.dll" (ByVal Filespec As String) As Boolean
Public Declare Function DirExists Lib "mslib145.dll" (ByVal Filespec As String) As Boolean
Public Declare Function GetAvailablePhysicalMemory Lib "mslib145.dll" () As Double
Public Declare Function GetTotalPhysicalMemory Lib "mslib145.dll" () As Double
Public Declare Function GetAvailableSwapfileMemory Lib "mslib145.dll" () As Double
Public Declare Function GetTotalSwapfileMemory Lib "mslib145.dll" () As Double
Public Declare Function GetAvailableVirtualMemory Lib "mslib145.dll" () As Double
Public Declare Function GetTotalVirtualMemory Lib "mslib145.dll" () As Double
Public Declare Function GetSystemDir Lib "mslib145.dll" () As String
Public Declare Function GetWindowsDir Lib "mslib145.dll" () As String
Public Declare Function GetUserDir Lib "mslib145.dll" () As String
Public Declare Function GetProfileDir Lib "mslib145.dll" (ByVal FolderFlags As Integer) As String
Public Declare Function WindowsSubVersion Lib "mslib145.dll" () As String
Public Declare Function WindowsVersion Lib "mslib145.dll" () As String
Public Declare Function GetLocalDriveStrings Lib "mslib145.dll" () As String
Public Declare Function GetAppFileName Lib "mslib145.dll" (Optional ByVal Handle As Long = 0&) As String
Public Declare Function GetDLLFileName Lib "mslib145.dll" () As String
Public Declare Function ShellRun Lib "mslib145.dll" (ByVal Command As String) _
    As Boolean
Public Declare Function GetDiskSize Lib "mslib145.dll" (ByVal DiskLetter As String, _
    Optional ByVal CompensateBy10K As Boolean = True) As Currency
Public Declare Function GetDiskSizeMb Lib "mslib145.dll" (ByVal DiskLetter As String) _
    As Long
Public Declare Function GetDiskSizeGb Lib "mslib145.dll" (ByVal DiskLetter As String) _
    As Double

' Alias for Win32 Sleep() with sanity-checks for parameters
Public Declare Sub WinSleep Lib "mslib145.dll" (ByVal Msecs As Integer)
Public Declare Function SetWallpaper Lib "mslib145.dll" (ByVal Filename As String, _
    Optional ByVal Style As Integer = 1) As Boolean  ' Default style is centred
Public Declare Function GetWallpaper Lib "mslib145.dll" () As String
Public Declare Function GetWallpaperStyle Lib "mslib145.dll" () As Integer

Public Declare Function ReadStringFromRegistry Lib "mslib145.dll" (ByVal hKey As Long, _
    ByVal SubKey As String, ByVal Value As String) As String
Public Declare Function WriteStringToRegistry Lib "mslib145.dll" (ByVal hKey As Long, _
    ByVal SubKey As String, ByVal Value As String, ByVal Data As String) As Boolean
Public Declare Function ReadDWORDFromRegistry Lib "mslib145.dll" (ByVal hKey As Long, _
    ByVal SubKey As String, ByVal Value As String, ByRef DWORDValue As Long) As Boolean
Public Declare Function WriteDWORDToRegistry Lib "mslib145.dll" (ByVal hKey As Long, _
    ByVal SubKey As String, ByVal Value As String, ByVal DWORDValue As Long) As Boolean
    
Public Declare Function GetOpenFile Lib "mslib145.dll" (ByVal hWnd As Any, _
    ByVal filter As String, ByVal title As String, _
    ByVal InitDir As String, ByVal flags As Integer) As String
Public Declare Function GetSaveFile Lib "mslib145.dll" (ByVal hWnd As Any, _
    ByVal filter As String, ByVal title As String, _
    ByVal InitDir As String, ByVal DefaultName As String, _
    ByVal flags As Integer) As String
    
Public Declare Function GetDiskType Lib "mslib145.dll" (ByVal DriveLetter As String) As Integer
Public Declare Function IsCDROMDisk Lib "mslib145.dll" (ByVal DriveLetter As String) As Boolean
Public Declare Function IsHardDisk Lib "mslib145.dll" (ByVal DriveLetter As String) As Boolean
Public Declare Function IsNetworkDisk Lib "mslib145.dll" (ByVal DriveLetter As String) As Boolean
Public Declare Function IsRAMDisk Lib "mslib145.dll" (ByVal DriveLetter As String) As Boolean
Public Declare Function IsRemovableDisk Lib "mslib145.dll" (ByVal DriveLetter As String) As Boolean
Public Declare Function IsValidDisk Lib "mslib145.dll" (ByVal DriveLetter As String) As Boolean
    
' File and Disk Functions
Public Declare Function AddTrailingSlash Lib "mslib145.dll" (ByVal Filename As String) As String
Public Declare Function FilenameMatch Lib "mslib145.dll" (ByVal Filename As String, _
    ByVal Wildcard As String) As Boolean
Public Declare Function FileType Lib "mslib145.dll" (ByVal Filename As String) As String
Public Declare Function GetNormalisedPath Lib "mslib145.dll" (ByVal Path As String) As String
Public Declare Function ListFiles Lib "mslib145.dll" (ByVal PathSpec As String, _
    Optional ByVal FileSpecs As String, Optional ByVal ArrayBase As Integer = 0) As Variant
Public Declare Function ReadFile Lib "mslib145.dll" Alias "_readfile" (ByVal Filename As String, _
    Optional ByVal Bytes As Long) As String
Public Declare Function FileCount Lib "mslib145.dll" (ByVal PathSpec As String) As Long
Public Declare Function WipeFile Lib "mslib145.dll" (ByVal Filename As String, Optional ExtraSecure As Boolean = True) As Integer

' Date and time functions
Public Declare Function ISOToUKDate Lib "mslib145.dll" (ByVal YYYYMMDD As String) As String
Public Declare Function UKToISODate Lib "mslib145.dll" (ByVal DDsMMsYYYY As String) As String
Public Declare Function UKShortToISODate Lib "mslib145.dll" (ByVal DDsMMsYY As String) As String
Public Declare Function IsLeapYear Lib "mslib145.dll" (ByVal Year As Integer) As Boolean
Public Declare Function NumOrd Lib "mslib145.dll" (ByVal N As Integer) As String
Public Declare Function PHPDate Lib "mslib145.dll" (ByVal d As Date, _
    Optional ByVal s As String) As String
Public Declare Function PHPDateNow Lib "mslib145.dll" (Optional ByVal s As String) As String
Public Declare Function VBDate Lib "mslib145.dll" (ByVal d As Date) As String
Public Declare Function VBDateMsecs Lib "mslib145.dll" (ByVal d As Date) As Integer
Public Declare Function VBDateToCTime Lib "mslib145.dll" (ByVal d As Date) As Double
Public Declare Function CTimeToVBDate Lib "mslib145.dll" (ByVal d As Double) As Date
Public Declare Function DSTAdjust Lib "mslib145.dll" (ByVal d As Date) As Double
Public Declare Function DateToHex Lib "mslib145.dll" (ByVal d As Date) As String
Public Declare Function HexToDate Lib "mslib145.dll" (ByVal s As String) As Double
' Alternate declaration
' Public Declare Function HexToDate Lib "mslib145.dll" (ByVal s As String) As Date

' Maths functions
Public Declare Function Ceil Lib "mslib145" (ByVal d As Double) As Double
Public Declare Function Floor Lib "mslib145" (ByVal d As Double) As Double
Public Declare Function Gcd Lib "mslib145.dll" (ByVal a As Long, ByVal b As Long) As Long
Public Declare Function Max Lib "mslib145.dll" (ByVal a As Integer, _
    ByVal b As Integer) As Integer
Public Declare Function Min Lib "mslib145.dll" (ByVal a As Integer, _
    ByVal b As Integer) As Integer
Public Declare Function Integral Lib "mslib145.dll" (ByVal d As Double) As Double
Public Declare Function Fraction Lib "mslib145.dll" (ByVal d As Double) As Double
#If VB5 Then  'VB5 et. al.
Public Declare Function Round Lib "mslib145.dll" (ByVal d As Double, _
    Optional ByVal Places As Integer) As Double
#Else
'Alias for VB6 etc.
Public Declare Function VBRound Lib "mslib145.dll" Alias "Round" (ByVal d As Double, _
    Optional ByVal Places As Integer) As Double
#End If

' IP address Network and Internet
Public Declare Function IPMatch Lib "mslib145.dll" (ByVal Mask As String, _
    ByVal IP As String) As Boolean
Public Declare Function IPToLong Lib "mslib145.dll" (ByVal IP As String) As Double
Public Declare Function LongToIP Lib "mslib145.dll" (ByVal IP As Double) As String
Public Declare Function MatchCIDR Lib "mslib145.dll" (ByVal Mask As String, _
    ByVal IP As String) As Boolean
Public Declare Function URLEncode Lib "mslib145.dll" (ByVal s As String) As String
Public Declare Function URLDecode Lib "mslib145.dll" (ByVal s As String) As String
Public Declare Function MapNetworkDrive Lib "mslib145.dll" (ByVal ServerPath As String, _
    ByVal DriveLetter As String, _
    ByVal UserName As String, _
    ByVal Password As String, _
    ByRef ErrorCode As Long, _
    Optional ByVal Persistent As Boolean = False, _
    Optional OfferPromptForLogin As Boolean = False) As Boolean
    
Public Declare Function MapNextFreeNetworkDrive Lib "mslib145.dll" (ByVal ServerPath As String, _
    ByVal UserName As String, _
    ByVal Password As String, _
    ByRef ErrorCode As Long, _
    Optional ByVal Persistent As Boolean = False, _
    Optional ByVal OfferPromptForLogin As Boolean = False) As String
    
Public Declare Function UnMapNetworkDrive Lib "mslib145.dll" (ByVal DriveLetter As String, _
    Optional ByVal Persistent As Boolean = False, _
    Optional ByVal ForceIt As Boolean = False) As Long
    
Public Declare Function DisconnectFromServer Lib "mslib145.dll" (ByVal ServerName As String, _
    Optional ByVal ForceIt As Boolean = False) As Long
Public Declare Function GetCGIArgs Lib "mslib145.dll" (ByVal s As String, _
    ByRef V As Variant) As Integer
Public Declare Function ArgFound Lib "mslib145.dll" (ByRef V As Variant, ByVal s As String, _
    Optional ByVal IgnoreCase As Boolean = True) As Boolean
Public Declare Function ArgVal Lib "mslib145.dll" (ByRef V As Variant, ByVal s As String, _
    Optional ByVal IgnoreCase As Boolean = True) As String
    
' Encoding
Public Declare Function Base64Filter Lib "mslib145.dll" (ByVal s As String) As String
'Note: Params below have changed from v1.02 - strings should now be ByRef for BSTR DLL calls
Public Declare Function EncodeString64 Lib "mslib145.dll" (ByRef sInput As String, _
    Optional ByVal WrapWidth As Integer = 0) As String
'Public Declare Function DecodeString64 Lib "mslib145.dll" (ByRef sInput As String) As String
Public Declare Function DecodeString64 Lib "mslib145.dll" (ByRef sInput As String, _
    ByRef NewLength As Long) As String

' Random number
Public Declare Sub Randomise Lib "mslib145.dll" (Optional ByVal Seed As Integer)
Public Declare Function Random Lib "mslib145.dll" (ByVal Lo As Long, ByVal Hi As Long) As Long
'Public Declare Function Random Lib "mslib145.dll" (ByVal Lo As Integer, _
'    ByVal Hi As Integer) As Long
Public Declare Function RandomStr Lib "mslib145.dll" (ByVal length As Long, _
    Optional ByVal Style As Integer = RandomStringMixedCase) As String
    Public Declare Function EncryptString Lib "mslib145.dll" (ByVal s As String, _
    ByVal length As Long, ByVal Password As String, Optional ByVal ExtraSecure As Boolean = True, _
    Optional ByVal Salt As String) As Boolean

' Merisenne Twister Random Number
Public Declare Sub MTRandomise Lib "mslib145.dll" (Optional ByVal Seed As Integer)
Public Declare Function MTRnd Lib "mslib145.dll" (ByVal Low As Long, ByVal High As Long) As Long
Public Declare Function MTRndDouble Lib "mslib145.dll" (ByVal Low As Double, ByVal High As Double) As Double
Public Declare Function MTRandomStr Lib "mslib145.dll" (ByVal length As Long, _
    Optional ByVal Style As Integer = RandomStringMixedCase) As String
    
' Console colours as per "C" conventions ///////////////////////////////////////////////
' Could call these DARK* and the LIGHT* versions just * since the DARK* are very dark
Public Const BACKGROUND_BLACK = 0
Public Const FOREGROUND_BLACK = 0
Public Const FOREGROUND_BLUE = 1
Public Const FOREGROUND_GREEN = 2
Public Const FOREGROUND_CYAN = 3
Public Const FOREGROUND_RED = 4
Public Const FOREGROUND_MAGENTA = 5
Public Const FOREGROUND_YELLOW = 6
Public Const FOREGROUND_GRAY = 7        ' Yep, American spelling
Public Const FOREGROUND_GREY = 7        ' UK (correct) spelling
Public Const FOREGROUND_INTENSITY = 8   ' Intensify the text colour

Public Const FOREGROUND_LIGHTBLUE = 1 Or FOREGROUND_INTENSITY
Public Const FOREGROUND_LIGHTGREEN = 2 Or FOREGROUND_INTENSITY
Public Const FOREGROUND_LIGHTCYAN = 3 Or FOREGROUND_INTENSITY
Public Const FOREGROUND_LIGHTRED = 4 Or FOREGROUND_INTENSITY
Public Const FOREGROUND_LIGHTMAGENTA = 5 Or FOREGROUND_INTENSITY
Public Const FOREGROUND_LIGHTYELLOW = 6 Or FOREGROUND_INTENSITY
Public Const FOREGROUND_WHITE = FOREGROUND_GREY Or FOREGROUND_INTENSITY

Public Const BACKGROUND_BLUE = 16
Public Const BACKGROUND_GREEN = 32
Public Const BACKGROUND_CYAN = 48
Public Const BACKGROUND_RED = 64
Public Const BACKGROUND_MAGENTA = 80
Public Const BACKGROUND_YELLOW = 96 ' Mustard
Public Const BACKGROUND_GRAY = 112
Public Const BACKGROUND_GREY = 112
Public Const BACKGROUND_INTENSITY = 128
Public Const BACKGROUND_WHITE = BACKGROUND_GRAY Or BACKGROUND_INTENSITY

'Console functions
Public Declare Function OpenConsole Lib "mslib145" () As Long
Public Declare Function GetConsoleHandle Lib "mslib145.dll" () As Long
Public Declare Function InNativeConsole Lib "mslib145" () As Boolean
Public Declare Function ConsoleOpen Lib "mslib145" () As Integer
Public Declare Sub CloseConsole Lib "mslib145" ()
Public Declare Sub SetConsoleAttributes Lib "mslib145" (ByVal Foreground As Integer, _
    ByVal Background As Integer)
Public Declare Sub ClearConsoleAttributes Lib "mslib145" ()
Public Declare Function HideConsole Lib "mslib145" () As Long
Public Declare Function ShowConsole Lib "mslib145" () As Long
Public Declare Function ConsoleTitle Lib "mslib145" (ByVal s As String) As Long
Public Declare Function WriteLn Lib "mslib145" (Optional ByVal s As String = "") As Long
'We can use WriteLn as a command to write a CRLF
Public Declare Function Writes Lib "mslib145" (ByVal s As String) As Long
Public Declare Function ReadLn Lib "mslib145" (ByVal l As Long) As String
Public Declare Sub Pause Lib "mslib145" (Optional ByVal s As String = "Press a key...")
Public Declare Sub Cls Lib "mslib145" ()
Public Declare Function WhereX Lib "mslib145" () As Integer
Public Declare Function WhereY Lib "mslib145" () As Integer
Public Declare Sub GotoXY Lib "mslib145" (ByVal x As Integer, ByVal y As Integer)
Public Declare Function InKey Lib "mslib145" () As Integer
Public Declare Function GetArgs Lib "mslib145.dll" (ByVal s As String, _
    ByRef V As Variant) As Integer
    
'Process info
Public Declare Function GetPID Lib "mslib145.dll" () As Long
Public Declare Function GetProcessMemoryUsed Lib "mslib145.dll" (ByVal PID As Long) As Long
    
'MAPI Email
Public Declare Function MapiSend Lib "mslib145.dll" (ByVal hWindParent As Long, _
    Optional ByVal strAttachmentName As String = "", _
    Optional ByVal strSubject As String = "", _
    Optional ByVal strMessage As String = "") As Boolean
    
'RLE Compression for bitmaps etc.
Public Declare Function RLECompressible Lib "mslib145.dll" (ByVal sInput As String) As Boolean
Public Declare Function RLECompress Lib "mslib145.dll" (ByVal sInput As String, _
    ByVal length As Long, Optional ByRef NewLength As Long) As String
Public Declare Function RLEByteCount Lib "mslib145.dll" (ByVal sInput As String) As Long
Public Declare Function RLECompressedByteCount Lib "mslib145.dll" (ByVal sInput As String, _
    ByVal length As Long) As Long
Public Declare Function RLEUncompressedByteCount Lib "mslib145.dll" (ByVal sInput As String) As Long
Public Declare Function RLEUncompress Lib "mslib145.dll" (ByVal sInput As String, _
    Optional ByRef NewLength As Long) As String


'/////////////////////////////////////////////////////////////////////////////////////////////////
        
'/////////////////////////////////////////////////////////////////////////////////////////////////

'Extras - not in this DLL but nevertheless interesting (uncomment to enable and try out)
'Use as ...
'debug.print vbexpression("msgbox " & chr$(34) & "Hello" & chr$(34) & ",vbInformation")
'vbexpression("pi = 22/7:msgbox pi")
'VB5 expression - evaluator
'Private Declare Function EbExecuteLine Lib "vba5.dll" (ByVal StringToExec As Long, ByVal Unknownn1 As Long, ByVal Unknownn2 As Long, ByVal fCheckOnly As Long) As Long
'VB6 expression-evaluator
'Private Declare Function EbExecuteLine Lib "vba6.dll" (ByVal StringToExec As Long, ByVal Unknownn1 As Long, ByVal Unknownn2 As Long, ByVal fCheckOnly As Long) As Long

'Public Function VBExpression(sCode As String, Optional fCheckOnly As Boolean) As Boolean
'   VBExpression = (EbExecuteLine(StrPtr(sCode), 0&, 0&, Abs(fCheckOnly)) = 0)
'End Function

'/////////////////////////////////////////////////////////////////////////////////////////////////

'Local VB DLL Wrapper Functions //////////////////////////////////////////////////////////////////

Public Sub VariantToArray(ByRef V As Variant, ByRef r() As String)
    'Purpose: Convert VB or VBToolbox Variant to a 1-dimensional VB String array()
    'Rationale: Cannot assign string array variants directly to string arrays
    'and there is no built-in conversion function
    
    'NOTE: Below is VB6 and higher only thus we must return a reference via the function body
    'Public Function VariantToArray(ByRef V As Variant) As String()
    
    'Lbound will be affected by the "Option Base" setting
    On Local Error Resume Next
    Dim i As Long
    If Not IsEmpty(V) Then
        ReDim r(UBound(V))
        For i = LBound(V) To UBound(V)
            r(i) = V(i)
        Next
    End If
End Sub
Public Function Base$(Value As Variant, BaseVal As Variant)
    'This is implemented as a VB-wrapper to take advantage of VarType()
    'Debug.Print "Base$() VarType(x)="; VarType(x)
    'Returns empty string on error
    Dim b As Byte   'Remove unsigned part
    On Error GoTo Error
    
    b = CByte(BaseVal) 'Convert 0..255 as DLL will only accept a byte 0..16
    Select Case (VarType(Value))
    Case vbByte:
        Base$ = StripTerminator(BaseConv(CByte(Value), b))  '0 to 255
        'Debug.Print "BaseConv(Byte)"
    Case vbInteger:
        Base$ = StripTerminator(BaseConv(CInt(Value), b))   '-32,768 to 32,767 (7FFF) fractions are rounded
        'Debug.Print "BaseConv(Integer)"
    Case vbLong:
        Base$ = StripTerminator(BaseConv(CLng(Value), b))   '-2,147,483,648 to 2,147,483,647 (7FFFFFFF) fractions are rounded.
        'Debug.Print "BaseConv(Long)"
    Case Default:
        'Debug.Print "BaseConv(Unknown)"
        Base$ = ""
    End Select
    Exit Function

Error:
    Debug.Print "Error" & Err.Description & " in Base$()"
    Resume Next
End Function
Public Function Bin$(x As Variant)
    'Debug.Print "VarType(x)="; VarType(x)
    On Error GoTo Error
    
    Select Case (VarType(x))
    Case vbByte:
        Bin$ = StripTerminator(Bin8(CByte(x)))
        'Debug.Print "Bin(Byte)"
    Case vbInteger:
        Bin$ = StripTerminator(Bin16(CInt(x)))
        'Debug.Print "Bin(Integer)"
    Case vbLong:
        Bin$ = StripTerminator(Bin32(CLng(x)))
        'Debug.Print "Bin(Long)"
    Case Default:
        'Debug.Print "Bin(Unknown)"
        Bin$ = ""

    End Select
    Exit Function

Error:
    Debug.Print "Error" & Err.Description & " in Bin$"
    Resume Next
End Function
Public Function IsVBToolboxDLLInstalled() As Boolean
    'IsDLLInstalled()
    'Logs a system-event error if the DLL was not found
    'Rename IsVBToolboxDLLInstalled() ?
    
    Dim r As Long
    IsVBToolboxDLLInstalled = True
    On Error GoTo NoDll
    
    r = LibVersion()           'This is common to all versions (was _libversion Alias)
    On Error GoTo 0
Fail:
    Exit Function

NoDll:
    IsVBToolboxDLLInstalled = False
    Debug.Print "Error "; Err.Number; " ("; Err.Description; ")  in IsDLLInstalled()"
    App.logevent vbCrLf & "Error " & Format$(Err.Number) & " - (" & Err.Description & ") in IsDLLInstalled", vbLogEventTypeError
    Resume Fail
End Function
Public Function VBStr(s As String) As String
    ' Convert a NULL-terminated C++ string to Vb
    ' Inadvertently named VBString() in earlier released - renamed to avoid conflict with VB
    ' VB happily permits NULL values in the middle of a string and prints as a space
    ' C and C DLLs use the NULL character to mark the end of the allocated string
    Dim i As Integer
    On Local Error Resume Next

    i = InStr(s, Chr$(0))
    If i > 0 Then
        s = Left$(s, i - 1)
    End If
    VBStr = s
End Function
Public Function StripTerminator(ByRef s As String) As String
   ' Strips a single terminator char - same as vbStr()
   Dim i As Integer
   On Local Error Resume Next
   
   i = InStr(s, Chr$(0))
   If i > 0 Then
      s = Left$(s, i - 1)
   End If
   StripTerminator = s
End Function
Public Function DLLVersion() As String
    'Version is an integer in the format "101"%->"1.01"$
    Dim VERNUM As Integer
    Dim Temp As String
    On Error GoTo NoDll

    Temp = "0.00"   'Default return (unknown)

    VERNUM = LibVersion()
    Temp = Format(VERNUM)
    If Len(Temp) = 3 Then
        Temp = Left$(Temp, 1) & "." & Right$(Temp, 2)
    End If
    DLLVersion = Temp
    Exit Function

NoDll:
    DLLVersion = "0.00"
    App.logevent "Error " & Format$(Err.Number) & " - " & Err.Description & ") in DLLVersion()", vbLogEventTypeWarning
    Resume Next
End Function

'EOF //////////////////////////////////////////////////////////////////////////////////

'PRIVATE DEVELOPER'S DEBUG ROUTINES BELOW // Not for consumer-use ///////////////////////////

'//////////////////////////////////////////////////////////////////////////////////////

Public Function BitPackToCArray(s As String, Optional StructWidth As Integer = 32) As String
    ' DEBUG only ///////////////////////////////////////////////////////
    ' A temporary debug-routine - this code may be deleted or ignored
    ' Debug function which creates a "C" source-code array (string) declaration holding Pi to 1302 places BitPacked down to 651 bytes
    ' M Shaw - June 2008 - DEBUGGING and DEVELOPMENT ONLY

    Dim r As String
    Dim l As Integer
    Dim i As Integer
    Dim t As String
    On Error GoTo Error
    
    Debug.Print "s="; StrToHex(s, Len(s))
    t = ""  ' Pre-empt failed return
    r = VBStr(BitPack(s))
    If r <> "" Then
        Debug.Print "r="; StrToHex(r, Len(r))
        t = "unsigned char myarray[]={" & vbCrLf
        l = Len(r)
        For i = 1 To l - 1
            t = t & "0x" & Hex$(Asc(Mid$(r, i, 1))) & ","
            If i > 0 And i Mod StructWidth = 0 Then t = t & vbCrLf
        Next
        t = t & "0x" & Hex$(Asc(Mid$(r, i, 2)))
        ' Print last with no comma postfix
        t = t & vbCrLf & "}; /* Array has " & Format$(l) & " byte(s) */"
    End If
    BitPackToCArray = t
    Exit Function

Error:
    Debug.Print "Error: " & Err.Description & " in BitPackToCArray()"
    Resume Next
End Function
Public Function IsoWeekNumber(d1 As Date) As Integer
    ' DEBUG DEBUG CODE ONLY - June 2008 ///////////////////////////////////////////////
    ' A temporary debug-routine - this code may be deleted or ignored
    ' Attributed to Daniel Maher - included for debug-comparison and checking with PHPDate(x,"W") only
    Dim d2 As Long
    d2 = DateSerial(Year(d1 - WeekDay(d1 - 1) + 4), 1, 3)
    IsoWeekNumber = Int((d1 - d2 + WeekDay(d2) + 5) / 7)
End Function

' ////////////////////////////////////////////////////////////////////////////////////

'Public Sub test()   ' This subroutine block may be safely-deleted
'    ' A temporary test-routine - this code may be safely deleted or simply ignored
'    ' These are basically sanity-checks and quick tests to be run when code is modified or updated
'    ' it's contents will change drastically from day-to-day and it may contain "dead" code
'    ' Yes, the use of GOTO is very bad (even in assembler eh?)
'
'    '1909 - user lockout
'    '2999 - no more drive letters
'    '#define ERROR_BAD_NET_NAME  67L
'    'ERROR_ALREADY_ASSIGNED  85L
'    'ERROR_BAD_DEVICE  1200L
'    'ERROR_BAD_LOGIN  1326L   //Unknown username or bad password
'    'ERROR_SESSION_CREDENTIAL_CONFLICT  1219
'    'ERROR_NOT_CONNECTED  2250
'
'    Dim i As Long    ' Always
'    Dim b As Boolean
'    Dim s As String
'    Dim v As Variant
'GoTo vttest
'GoTo TestLogEvent
'    'Debug.Print "REG:Wallpaper SET=["; WriteStringToRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "wallpaper", "Fred.bmp"); "]"
'    'Debug.Print "REG:Wallpaper    =["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "wallpaper"); "]"
'    'GoTo Wallpaper
'End
'
'    '//////////////////////////////////////////
'    'Test Get disk drive types
''    For i = Asc("C") To Asc("F")
''    Debug.Print "GetDiskType for drive "; Chr$(i); ": is ("; GetDiskType(Chr$(i)); ")"
''    Debug.Print "IsValidDisk("; Chr$(i); ":) is "; IsValidDisk(Chr$(i))
''    If IsHardDisk(Chr$(i)) Then Debug.Print "IsHardDisk("; Chr$(i); ":) is "; IsHardDisk(Chr$(i))
''    If IsRAMDisk(Chr$(i)) Then Debug.Print "IsRAMDisk("; Chr$(i); ":) is "; IsRAMDisk(Chr$(i))
''    If IsNetworkDisk(Chr$(i)) Then Debug.Print "IsNetworkDisk("; Chr$(i); ":) is "; IsNetworkDisk(Chr$(i))
''    If IsCDROMDisk(Chr$(i)) Then Debug.Print "IsCDROMDisk("; Chr$(i); ":) is "; IsCDROMDisk(Chr$(i))
''    If IsRemovableDisk(Chr$(i)) Then Debug.Print "IsRemovableDisk("; Chr$(i); ":) is "; IsRemovableDisk(Chr$(i))
''    Next
''    i = Asc("Q")
''    Debug.Print "CHECK GetDiskType for drive "; Chr$(i); ": is ("; GetDiskType(Chr$(i)); ")"
''    Debug.Print "IsValidDisk("; Chr$(i); ":) is "; IsValidDisk(Chr$(i))
''    If IsHardDisk(Chr$(i)) Then Debug.Print "IsHardDisk("; Chr$(i); ":) is "; IsHardDisk(Chr$(i))
''    If IsRAMDisk(Chr$(i)) Then Debug.Print "IsRAMDisk("; Chr$(i); ":) is "; IsRAMDisk(Chr$(i))
''    If IsNetworkDisk(Chr$(i)) Then Debug.Print "IsNetworkDisk("; Chr$(i); ":) is "; IsNetworkDisk(Chr$(i))
''    If IsCDROMDisk(Chr$(i)) Then Debug.Print "IsCDROMDisk("; Chr$(i); ":) is "; IsCDROMDisk(Chr$(i))
''    If IsRemovableDisk(Chr$(i)) Then Debug.Print "IsRemovableDisk("; Chr$(i); ":) is "; IsRemovableDisk(Chr$(i))
''
''    i = Asc("Z") + 1
''    Debug.Print "CHECK GetDiskType for drive "; Chr$(i); ": is ("; GetDiskType(Chr$(i)); ")"
''    Debug.Print "IsValidDisk("; Chr$(i); ":) is "; IsValidDisk(Chr$(i))
''    If IsHardDisk(Chr$(i)) Then Debug.Print "IsHardDisk("; Chr$(i); ":) is "; IsHardDisk(Chr$(i))
''    If IsRAMDisk(Chr$(i)) Then Debug.Print "IsRAMDisk("; Chr$(i); ":) is "; IsRAMDisk(Chr$(i))
''    If IsNetworkDisk(Chr$(i)) Then Debug.Print "IsNetworkDisk("; Chr$(i); ":) is "; IsNetworkDisk(Chr$(i))
''    If IsCDROMDisk(Chr$(i)) Then Debug.Print "IsCDROMDisk("; Chr$(i); ":) is "; IsCDROMDisk(Chr$(i))
''    If IsRemovableDisk(Chr$(i)) Then Debug.Print "IsRemovableDisk("; Chr$(i); ":) is "; IsRemovableDisk(Chr$(i))
''
''End
'    ' bug - adds vb5.exe in IDE
'TestLogEvent:
'    ' Test "NT" event-logging //////////////////////////////////////////////////////////////////////////
'    Debug.Print "getdllfilename="; GetDLLFileName()
'    'Debug.Print "RemoveEventSource="; RemoveEventSource("VBToolbox")
'    If Not IsEventSource("VBToolbox") Then
'        Debug.Print "VBToolbox is not set as an event-source"
'        Debug.Print "ADDING NEW - AddEventSource="; AddEventSource("VBToolbox", 0)
'    End If
'    Debug.Print "LogEvent="; logevent("VBToolbox", vbCrLf & "Testing SUCCESS message", EVENTLOG_SUCCESS, vbCrLf & "(Error: 0x00)")
'    DoEvents
'
'    Debug.Print "LogEvent="; logevent("VBToolbox", "Test ERROR message", EVENTLOG_ERROR_TYPE, vbCrLf & "(Error: 0x01)")
'    DoEvents
'    Debug.Print "LogEvent="; logevent("VBToolbox", "Test WARNING message", EVENTLOG_WARNING_TYPE, vbCrLf & "(Error: 0x02)")
'    DoEvents
'
'    Debug.Print "LogEvent="; logevent("VBToolbox", "Test INFORMATION message", EVENTLOG_INFORMATION_TYPE, vbCrLf & "(Error: 0x03)")
'    DoEvents
'    Debug.Print "LogEvent="; logevent("VBToolbox", "Test AUDIT-SUCCESS message", EVENTLOG_AUDIT_SUCCESS, vbCrLf & "(Error: 0x04)")
'    DoEvents
'    Debug.Print "LogEvent="; logevent("VBToolbox", "Test AUDIT-FAILURE message", EVENTLOG_AUDIT_FAILURE, vbCrLf & "(Error: 0x05)")
'    DoEvents
'End
'
'vttest:
'    'Test query string CGIArgs()
'    'QUERY_STRING=submit=true&arg2=2&another=3
'    ' Useage: i=GetCGIArgs(environ("QUERY_STRING"),v)
'    's = "fred.cgi?one=1&2=two&three=three"
'    s = "submit=true&arg 2=2&another%20one=3&something%20else=four&no encode=5"
'    'Debug.Print "Variant array dimensions are ["; GetArrayDimensions(V); "]"
'    Dim v1(10) As Variant
'    Dim vt(10, 1) As Variant
'    Dim V2 As Variant
'    'vt(1, 0) = "one"
'    'vt(2, 0) = "Two"
'    'vt(3, 0) = 23534
'    Debug.Print "UBound(vt)="; UBound(vt)
'    Debug.Print "Variant array dimensions of VB v1 (x) are ["; GetArrayDimensions(v1); "]"
'    Debug.Print "Variant array dimensions of VB vt (x,y) are ["; GetArrayDimensions(vt); "]"
'    Debug.Print "Variant array dimensions of (empty) v are ["; GetArrayDimensions(v); "]"
'
'    's = "c:\windows\woods*.* /q"
'    i = GetCGIArgs(URLDecode(s), v)
'    'i = GetArgs(s, V)
'    Debug.Print "Type of (empty) v is "; TypeName(VarType((v))); " #"; VarType(v) ' Crash!
'    'V = Tokenise(s, "&")
'    Debug.Print "Returned argument count was "; i
'    If Not IsEmpty(v) Then
'        Debug.Print "Variant array dimensions of (filled) v are ["; GetArrayDimensions(v); "]"
'        Debug.Print "Lbound of v is "; LBound(v)
'        Debug.Print "Ubound of v is "; UBound(v)
'        'Debug.Print "Type of (filled) v is "; VarType((V)) ' Crash!
'        For i = LBound(v) To UBound(v)
''BUG returning wrong type - thus cannot chain other functs without cstr()
'            Debug.Print "item "; i; ":=["; v(i); "] vartype="; VarType(v(i)); "("; TypeName(v(i))
'            'Debug.Print CStr(V(i))
'            'Debug.Print "item "; i; ":=["; (v(i)); "]"
'        Next
'        'Debug.Print i
'    End If
'    Debug.Print "ArgFound(v,  another one)="; ArgFound(v, "another one", True)
'    Debug.Print "ArgVal(v,  another one)=["; ArgVal(v, "another one", True); "]"
'
'End
'
'    v = ListFiles("c:\*.sys", "")
'    Debug.Print "Variant array dimensions of v are ["; GetArrayDimensions(v); "]"
'    Debug.Print "Ubound(v)="; UBound(v)
'    V2 = ListFiles("c:\*.txt", "")
'    Debug.Print "Ubound(v)="; UBound(V2)
'    If Not IsEmpty(v) Then Debug.Print "v(0)=("; v(0); ") *.sys"
'    If Not IsEmpty(v) Then Debug.Print "v(1)=("; v(1); ") *.sys"
'    If Not IsEmpty(V2) Then Debug.Print "v2(0)=("; V2(0); ") *.txt"
'    If Not IsEmpty(V2) Then Debug.Print "v2(1)=("; V2(1); ") *.txt"
'End
'    ' Test drive-mapping ////////////////////////////////////////////////////////////////////////
'    Dim ErrorCode As Long
'    Dim dr As String
'    Dim ServerName As String
'    Dim UserName As String
'    Dim Password As String
'    ErrorCode = 0
'    ServerName = "\\xxxx"
'    UserName = "Admin"
'    Password = "******"
'
''    Debug.Print "Attaching to server "; ServerName
''    b = AttachToServer(ServerName, UserName, Password, errorcode)
''    Debug.Print "AttachToServer("; ServerName; ")="; b
''    Debug.Print "AttachingToServer errorcode=["; NetErrorMsg(errorcode) "]"
'
'    Debug.Print "Disconnecting..."
'    ErrorCode = DisconnectFromServer(ServerName)
'    Debug.Print "DisconnectFromServer Drive errorcode=["; NetErrorMsg(ErrorCode); "]"
'    Debug.Print "Done."
'
'    dr = "q:"
'    Debug.Print "Unmapping "; dr
'    ErrorCode = UnMapNetworkDrive(dr)
'    Debug.Print "UnMapNetworkDrive=["; NetErrorMsg(ErrorCode); "]"
'
'    'Use vbNullString to pass "NULL" to "C" routines
'    'Debug.Print "MapNetworkDrive="; MapNetworkDrive(ServerName & "\drive-d$", dr, UserName, Password, ErrorCode, False, True)
'    Debug.Print "MapNetworkDrive="; MapNetworkDrive(ServerName & "\drive-d$", dr, vbNullString, vbNullString, ErrorCode)
'    Debug.Print "MapNetworkDrive Q: errorcode=["; NetErrorMsg(ErrorCode); "]"
'    Debug.Print "DriveExists(Q:)="; DriveExists("Q:")
'
'    For i = 1 To 1
'    Debug.Print "Mapping next free drive..."
'    'dr = MapNextFreeNetworkDrive(ServerName & "\drive-d$", UserName, Password, ErrorCode)
'    dr = MapNextFreeNetworkDrive(ServerName & "\drive-d$", vbNullString, vbNullString, ErrorCode)
'    Debug.Print "MapNextFreeNetworkDrive drive return ("; i; ") was ["; dr; "]"
'    Debug.Print "MapNextFreeNetwork Drive errorcode=["; NetErrorMsg(ErrorCode); "]"
'    Next
'
'    Debug.Print "Disconnecting..."
'    ErrorCode = DisconnectFromServer(ServerName)
'    Debug.Print "DisconnectFromServer Drive errorcode=["; NetErrorMsg(ErrorCode); "]"
'
'    dr = "q:"
'    Debug.Print "Unmapping "; dr
'    ErrorCode = UnMapNetworkDrive(dr, False, True)
'    Debug.Print "UnMapNetworkDrive=["; NetErrorMsg(ErrorCode); "]"
'    Debug.Print "DriveExists(Q:)="; DriveExists("Q:")
'    Debug.Print "Done."
'
'End
'' Test ShellRun()
''    Debug.Print ShellRun("mailto:someone@someisp.com?subject=Test email&body=Hello there")
''    Debug.Print ShellRun("http://www.google.com")
''End
'' Test ListFiles()
''    v = ListFiles("c:\temp\*.*", "*.jpg, *.txt, *.log")
''    Debug.Print IsEmpty(v)
''    If Not IsEmpty(v) Then
''        i = UBound(v)
''        Debug.Print "Ubound="; i
''        i = LBound(v)
''        Debug.Print "Lbound="; i
''        Debug.Print "V item one ["; v(LBound(v)); "]"
''        For i = LBound(v) To UBound(v)
''            'If FileType(v(i)) = "jpg" Then
''                Debug.Print "item "; i; " = ["; v(i); "] typ="; FileType(CStr(v(i)))
''            'End If
''        Next
''    Else
''        Debug.Print "Array V is emtpy!"
''    End If
'End
''    Debug.Print RotateLong(RotateLong(987654321))   ' Test little-endian byte rotation
''    Debug.Print RotateLong(RotateLong(0&))          ' Test by cyclic-inverting
''    Debug.Print RotateLong(RotateLong(-1))
''    Debug.Print RotateLong(RotateLong(1))
''    Debug.Print RotateInt(RotateInt(12345))
''    Debug.Print RotateInt(RotateInt(0))
''    Debug.Print RotateInt(RotateInt(-1))
''    Debug.Print RotateInt(RotateInt(1))
''    Debug.Print RotateByte(RotateByte(123))
''    Debug.Print RotateByte(RotateByte(0))
''    Debug.Print RotateByte(RotateByte(1))
'    End
'
''    ' Test JPEGHeader on good and known-damaged files
''    Dim Width As Integer
''    Dim Height As Integer
''    Dim Length As Long
''    Debug.Print JPEGHeader("damaged\bad.jpg", Width, Height, Length)
''    Debug.Print "BAD Length="; Length; " - 512 x 768"
''    Debug.Print "BAD Width="; Width
''    Debug.Print "BAD Height="; Height
''    Debug.Print JPEGCheck("damaged\bad.jpg")
''    Debug.Print JPEGHeader("damaged\good.jpg", Width, Height, Length)
''    Debug.Print "GOOD Length="; Length; "- 536 x 752 (57762)"
''    Debug.Print "GOOD Width="; Width
''    Debug.Print "GOOD Height="; Height
''    Debug.Print JPEGCheck("damaged\good.jpg")
''    Debug.Print JPEGHeader("damaged\s.jpg", Width, Height, Length)
''    Debug.Print "BAD Length="; Length; " - "
''    Debug.Print "BAD Width="; Width
''    Debug.Print "BAD Height="; Height
''    Debug.Print JPEGCheck("damaged\suzan.jpg")
''    Debug.Print JPEGHeader("damaged\nosuch.jpg", Width, Height, Length)
''    Debug.Print "BAD Length="; Length; " - "
''    Debug.Print "BAD Width="; Width
''    Debug.Print "BAD Height="; Height
''    Debug.Print JPEGCheck("damaged\nosuch.jpg")
'End
'' Test for documentation code
''    Dim str As String
''    str = "The quick, brown fox jumped over the lazy dog"
''    v = Tokenise(str, " ")
''    If Not IsEmpty(v) Then
''        For i = LBound(v) To UBound(v)
''            Debug.Print v(i)
''        Next
''    End If
''    End
'End
'
'' ''Console InKey() test /////////////////////////////////////////////////////////
''    ''Dim i As Integer
''    Debug.Print "Opening console"
''    If OpenConsole() Then
''        'i = Inkey()
''        Dim j As Integer
''        i = InKey()
''        Do While i = 0
''            GotoXY 1, 1
''            WriteLn "Waiting..." & Format$(j) & " key=" & Format$(i)
''
''            Debug.Print i
''            DoEvents
''            WinSleep 100
''            DoEvents
''            'If i > 0 Then Exit Do
''            j = j + 1
''            i = InKey()
''        Loop
''        CloseConsole
''    End If
''Debug.Print "closed console"
'End
'
'' Tokenising test
''    Dim a(10) As String
''    a(0) = "1"
''    a(1) = "2"
''    a(3) = "3"
''    Dim size As Integer
''    Dim which As Integer
''    size = 10
''    which = 2
''    Dim v As Variant
''    'v = ArrayTest()
''    'v = GetArgs("/one /two,/time=3 /four")
''    'Debug.Print GetArgs("", v)
''    'Debug.Print GetArgs("/one /two,/time=3 /four", v)
''    'v = Tokenise("/one /two,/time=3 /four", " ,") ' OK/PASS
''    'v = Tokenise("", " ,")   ' OK/PASS
''    i = GetArgs("", v) ' OK/PASS
''    'i = GetArgs("/one /two,/time=3 /four", v) ' OK/PASS
''    Debug.Print i; " item(s) were returned"
''    Debug.Print "Typename ArrayTest()="; TypeName(v)
''    Debug.Print "vartype v="; VarType(v) '8200=vbArray 8192    Array + vbString    8   String
''    Debug.Print "isempty(v)="; IsEmpty(v)
''    Debug.Print "isNull(v)="; IsNull(v)
''    If Not IsEmpty(v) Then
''        Debug.Print "Lbound v="; LBound(v)
''        Debug.Print "Ubound v="; UBound(v)
''        'Debug.Print "v0-"; v(0)
''        For i = LBound(v) To UBound(v)
''            Debug.Print "V("; i; ")=["; v(i); "] len="; Len(v(i))
''        Next
''    End If
''
''    End
'    'Debug.Print "ArrayTest=["; ArrayTest(a, size, which); "]"
'
'    ' Wallpaper and Registry checks ==========================
'Wallpaper:
'
'    Dim mode As Integer
'    Dim wp As String
'    Debug.Print SetWallpaper("C:\Documents and Settings\Admin\Local Settings\Application Data\Microsoft\Wallpaper1.bmp", 4)
'    Debug.Print "REG:Wallpaper["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "wallpaper"); "]"
'    Debug.Print "REG:WallpaperStyle["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "WallpaperStyle"); "]"
'    Debug.Print "REG:TileWallpaper["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "Tilewallpaper"); "]"
'    Debug.Print "Original wallpaper has been set"
'    wp = GetWallpaper()    'WallpaperStyle | TileWallpaper 1=Normal (centre), 2=(reserved), 4=Stretch, 8=tile
'    mode = GetWallpaperStyle()
'    Debug.Print "start mode=(", mode; ")["; wp; "]" ' Our modes 1=normal, 2=tile, 4=stretch, 8=tile
'    WinSleep 2000
'    Debug.Print "NEW: SetWallpaper="; SetWallpaper("c:\windows\winnt.bmp")
'    WinSleep 2000
'
'    Debug.Print "Change TILED..."; SetWallpaper("", 2)  ' tile
'    WinSleep 2000
'
'    Debug.Print "Change STRETCH..."; SetWallpaper("", 4)  ' Stretch
'    WinSleep 2000
'
'    Debug.Print "Change CENTRED (again)..."; SetWallpaper("c:\_w\", 1)
'    WinSleep 2000
'
'    Debug.Print "REG:Wallpaper["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "wallpaper"); "]"
'    Debug.Print "REG:WallpaperStyle["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "WallpaperStyle"); "]"
'    Debug.Print "REG:TileWallpaper["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "Tilewallpaper"); "]"
'    Debug.Print "mode=(", mode; ")"
'    Debug.Print "mode: GetWallpaper=["; GetWallpaperStyle(); "] (", mode; ")"
'    Debug.Print "SetWallpaper(original)="; SetWallpaper(wp, mode) ' Put original wallpaper back
'    Debug.Print "REG:Wallpaper["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "wallpaper"); "]"
'    Debug.Print "REG:WallpaperStyle["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "WallpaperStyle"); "]"
'    Debug.Print "REG:TileWallpaper["; ReadStringFromRegistry(HKEY_CURRENT_USER, "Control Panel\desktop", "Tilewallpaper"); "]"
'
'End
'    ' Some sanity checks on Replace() ======================
''    Dim r As String
''    For i = 1 To 10000
''        s = "the quick brown fox jumped over the lazy dog"
''        'Debug.Print "Length="; Len(s)
''        r = Replace(s, " ", "")
''        If Len(r) <> 36 Then
''            Debug.Print "["; r; "]"; "(check remove all spaces)"
''            Debug.Print StrToHex(r)
''            Debug.Print Len(r); "(check remove all spaces)"
''        End If
''        s = "ooooooooohooooooooooooeooooooooooooooloolooooooooooooO"    '54
''        'Debug.Print "Length="; Len(s)
''        r = Replace(s, "o", "")
''        If Len(r) <> 5 Or r <> "hellO" Then
''            Debug.Print "["; r; "]"; "(check remove all o)"
''            Debug.Print StrToHex(r)
''            Debug.Print Len(r); "(check remove all spaces)"
''            Debug.Print "checked"; i; "FAIL"
''            End
''        End If
''        s = "ooooooooooooooooooooooooooooooooooooooooooooooooo"
''        'Debug.Print "Length="; Len(s)
''        r = Replace(s, "o", "")
''        If Len(r) <> 0 Then
''            Debug.Print "["; r; "]"; "(check remove all o)"
''            Debug.Print StrToHex(r)
''            Debug.Print Len(r); "(check remove all o)"
''            Debug.Print "checked"; i; "FAIL"
''            End
''        End If
''        s = RandomStr(100) ' clear memory
''    Next
''    Debug.Print "loop-checked"; i - 1; "OK --------------"
''    s = "the quick brown fox jumped over the lazy dog"
''    Debug.Print Replace(s, "e", "Q")
''    Debug.Print Replace(s, " ", "Q")
''    Debug.Print Replace(s, "o", "Q")
''    s = "the quick brown fox jumped over the lazy dog"
''    Debug.Print "["; Replace(s, "fox", "dinosaur"); "]"
''    s = "the quick brown fox jumped over the lazy dog"
''    Debug.Print Replace(s, "quick brown", "dashing silver")
''    s = "the quick brown fox jumped over the lazy dog"
''    Debug.Print Replace(s, "", "dinosaur"); "(check null search)"
''    s = "the quick brown fox jumped over the lazy dog"
''    Debug.Print Replace(s, "fox ", ""); "(shrink - null replace)"
''    s = "the quick brown fox jumped over the lazy dog"
''    Debug.Print Replace(s, "fox ", 0); "(shrink - null replace - VB replaces with zero string)"
''    s = "the quick brown fox jumped over the lazy dog"
''    Debug.Print Replace(s, "", ""); "(check null params)"
''    Debug.Print Replace(s, "", 0); "(check null params)"
''    Debug.Print Replace(s, 0, ""); "(check null params)"
''    Debug.Print Replace(s, 0, 0); "(check null params)"
'End ' //////////////////////////////////////////////////////////////////////////////
'
''    PISTR REMOVED 03/09/2009 'PiStr() and BitUnpack mods
''    Debug.Print StrToHex(BitPack("1.234567890"))
''    Debug.Print BitUnPack(BitPack("1.234567890"))
''    For i = 1 To 20: Debug.Print Format$(i, "00"); "=["; PiStr(i); "]"; Len(VBStr(PiStr(i))): Next
'End
'
'    ' Test VB to C date functions //////////////////////////////////////////////////
'    Debug.Print "VBDate(#9/9/2001 1:46:40 AM#)="; VBDate(#9/9/2001 1:46:40 AM#)
'    Debug.Print "VBDateToCTime(#1/1/1970#)="; VBDateToCTime(#1/1/1970#); " (zero day)"
'    Debug.Print "CTimeToVBDate(VBDateToCTime(#1/1/1970#))="; CTimeToVBDate(VBDateToCTime(#1/1/1970#)); " (zero day)"
'    Debug.Print "VBDateToCTime(#9/1/2001 1:46:40 AM#)="; VBDateToCTime(#9/1/2001 1:46:40 AM#)
'    Debug.Print "VBDateToCTime(#9/9/2001#)="; VBDateToCTime(#9/9/2001#)
'    Debug.Print "CTimeToVBDate(VBDateToCTime(#9/9/2001 1:46:40 AM#))="; CTimeToVBDate(VBDateToCTime(#9/9/2001 1:46:40 AM#))
'    Debug.Print "Cycle test NOW="; CTimeToVBDate(VBDateToCTime(Now))
'    Debug.Print "VBDateToCTime(#9/9/2001 1:46:40 AM#)="; VBDateToCTime(#9/9/2001 1:46:40 AM#); " (should be 1000000000)" ' At 01:46:40 UTC on September 9, 2001, the Unix billennium (Unix time number 1000000000) was celebrated."
'    Debug.Print "PHPDate(#9/9/2001 1:46:40 AM#,  U )=("; PHPDate(#9/9/2001 1:46:40 AM#, "U"); ") (should be 1000000000)"
'    Debug.Print "PHPDate(#9/9/2001 1:46:40 AM#,  r )=("; PHPDate(#9/9/2001 1:46:40 AM#, "r"); ")"
'    Debug.Print "VBDateToCTime is:"; 1000000000 - VBDateToCTime(#9/9/2001 1:46:40 AM#); " seconds out"
'    End
'
'GoTo Bpack
'    ' A few test for PHPDate(x,"W")
'    '   Our call, (read from calendar), cross-check from VB code
'    'Check selected dates against a physical calendar for ISO week number values and cross-check back
'    Debug.Print vbStr(PHPDate(Now, "Y/m/d - W")); "(NOW)"; IsoWeekNumber(Now)
'    Debug.Print vbStr(PHPDate(#1/1/1970#, "Y/m/d - W")); "(1)"; IsoWeekNumber(#1/1/1970#)
'    Debug.Print vbStr(PHPDate(#1/2/1970#, "Y/m/d - W")); "(1)"; IsoWeekNumber(#1/2/1970#)
'    Debug.Print vbStr(PHPDate(#1/3/1970#, "Y/m/d - W")); "(1)"; IsoWeekNumber(#1/3/1970#)
'    Debug.Print vbStr(PHPDate(#1/4/1970#, "Y/m/d - W")); "(1)"; IsoWeekNumber(#1/4/1970#)
'    Debug.Print vbStr(PHPDate(#1/5/1970#, "Y/m/d - W")); "(2)"; IsoWeekNumber(#1/5/1970#)
'    Debug.Print vbStr(PHPDate(#1/6/1970#, "Y/m/d - W")); "(2)"; IsoWeekNumber(#1/6/1970#)
'    Debug.Print vbStr(PHPDate(#3/1/1970#, "Y/m/d - W")); "(9)"; IsoWeekNumber(#3/1/1970#)
'    Debug.Print vbStr(PHPDate(#3/2/1970#, "Y/m/d - W")); "(10)"; IsoWeekNumber(#3/2/1970#)
'    Debug.Print vbStr(PHPDate(#1/4/1992#, "Y/m/d - W")); "(1)", IsoWeekNumber(#1/4/1992#)
'    Debug.Print vbStr(PHPDate(#1/5/1992#, "Y/m/d - W")); "(1)"; IsoWeekNumber(#1/5/1992#)
'    Debug.Print vbStr(PHPDate(#1/6/1992#, "Y/m/d - W")); "(2)"; IsoWeekNumber(#1/6/1992#)
'    Debug.Print vbStr(PHPDate(#1/28/1992#, "Y/m/d - W")); "(5)"; IsoWeekNumber(#1/28/1992#)
'    Debug.Print vbStr(PHPDate(#5/28/1992#, "Y/m/d - W")); "(22)"; IsoWeekNumber(#5/28/1992#)
'    Debug.Print vbStr(PHPDate(#8/28/1992#, "Y/m/d - W")); "(35)"; IsoWeekNumber(#8/28/1992#)
'    Debug.Print vbStr(PHPDate(#12/28/1992#, "Y/m/d - W")); "(53)"; IsoWeekNumber(#12/28/1992#)
'    Debug.Print vbStr(PHPDate(#1/5/2008#, "Y/m/d - W")); "(1)"; IsoWeekNumber(#1/5/2008#)
'    Debug.Print vbStr(PHPDate(#1/6/2008#, "Y/m/d - W")); "(1)"; IsoWeekNumber(#1/6/2008#)
'    Debug.Print vbStr(PHPDate(#1/7/2008#, "Y/m/d - W")); "(2)"; IsoWeekNumber(#1/7/2008#)
'    Debug.Print vbStr(PHPDate(#1/8/2008#, "Y/m/d - W")); "(2)"; IsoWeekNumber(#1/8/2008#)
'    Debug.Print vbStr(PHPDate(#1/28/2008#, "Y/m/d - W")); "(5)"; IsoWeekNumber(#1/28/2008#)
'    Debug.Print vbStr(PHPDate(#5/28/2008#, "Y/m/d - W")); "(22)"; IsoWeekNumber(#5/28/2008#)
'    Debug.Print vbStr(PHPDate(#8/28/2008#, "Y/m/d - W")); "(35)"; IsoWeekNumber(#8/28/2008#)
'    Debug.Print vbStr(PHPDate(#12/28/2008#, "Y/m/d - W")); "(52)"; IsoWeekNumber(#12/28/2008#)
'
'    'Debug.Print "PHPDate(#1/1/1970#, r)="; PHPDate(#1/8/1970#, "U")
'    'Debug.Print "PHPDate(#1/1/1970 1:02:03 AM#, "; r; ")="; PHPDate(#1/1/1970 1:02:03 AM#, "r")
'    'Debug.Print "PHPDate(32000 r)=" & PHPDate(32000, "r")
'    'Debug.Print "VBDateToCTime(#1/8/1970 0:0:0#)="; VBDateToCTime(#1/8/1970#)
'End
'
''    Dim d As Date
''    d = #1/1/1970#  ' VB strips 00:00:00 from the end automatically!!!!
''    d = #5/2/2008 12:01:02 AM# ' Unix epoch end (actually ends midnight on 25th)
''    d = #6/20/2008 10:12:01 PM#
'End
'
'Bpack:
''    Dim s As String
''    ' Pi to 1302 places (compresses to 651 bytes)
''    s =  "3.1415926535897932384626433832795028841971693993751058209749445923078164062862089986280348253421170679"
''    s =  b & "8214808651328230664709384460955058223172535940812848111745028410270193852110555964462294895493038196"
''    s =  b & "4428810975665933446128475648233786783165271201909145648566923460348610454326648213393607260249141273"
''    s =  b & "7245870066063155881748815209209628292540917153643678925903600113305305488204665213841469519415116094"
''    s =  b & "3305727036575959195309218611738193261179310511854807446237996274956735188575272489122793818301194912"
''    s =  b & "9833673362440656643086021394946395224737190702179860943702770539217176293176752384674818467669405132"
''    s =  b & "0005681271452635608277857713427577896091736371787214684409012249534301465495853710507922796892589235"
''    s =  b & "4201995611212902196086403441815981362977477130996051870721134999999837297804995105973173281609631859"
''    s =  b & "5024459455346908302642522308253344685035261931188171010003137838752886587533208381420617177669147303"
''    s =  b & "5982534904287554687311595628638823537875937519577818577805321712268066130019278766111959092164201989"
''    s =  b & "3809525720106548586327886593615338182796823030195203530185296899577362259941389124972177528347913151"
''    s =  b & "5574857242454150695950829533116861727855889075098381754637464939319255060400927701671139009848824012"
''    s =  b & "8583616035637076601047101819429555961989467678374494482553797747268471040475346462080466842590694912"
''    Debug.Print "Pi has " & Len(b); " places"
''    Debug.Print BitPackToCArray(b, 32)
'
''    s = "00000"  '
''    s = "900012345067890abc8978"
''    s = "+,-. 0123456790abcde"
''    s = "  +3.1415926535897932384626433832795028841971693993751058209749445923078164062862089986280348253421170679"
''    s = "+1 234 567"
''    Debug.Print "Packing    ["; s
''    Debug.Print "Bitpack=   ["; BitPack(s); "]"
''    Debug.Print "Len=       ["; Len(s); "->"; Len(BitPack(s)); "]"
''    Debug.Print "Bitpack HEX["; StrToHex(BitPack(s)); "]"
''    Debug.Print "BitUnPack= ["; BitUnPack(BitPack(s)); "]"
''    Debug.Print "-------------"
'End
'
''GoTo Skip
''    For i = 1 To 100
''        d = Now
''        Debug.Print CDbl(d); " ";
''        Debug.Print vbStr(VBDate(d)); " ";
''        Debug.Print VBDateMsecs(d); " ";
''        Debug.Print Format(d, "[hh:mm:ss]"); " ";
''        Debug.Print PHPDate(DSTAdjust(d), "H:i:s")
''
''        WinSleep 100
''    Next
''    Debug.Print d, PHPDate(DSTAdjust(d))
'End
'
'Skip:
''
''    Dim u As Double
''    Debug.Print "d is: "; d
''    Debug.Print "d time is: "; Format(d, "Long Time")
''    u = CDbl(d)
''    Debug.Print "D is stored as "; Format(d, "yyyy/mmm/dd")
''
''    Debug.Print "cdbl(d) as u="; u
''    Debug.Print "VBDateToCTime(d)="; VBDateToCTime(d)
''    ' Test for Fraction() and Integral()
''    Debug.Print "Fraction(u):     "; Fraction(u)
''    Debug.Print "Integral(u):"; Integral(u)
''    Debug.Print "VBDateMsecs(u)="; VBDateMsecs(d)
''    'OK (((fraction(39619.4786805556) * 1000000.0))*1000 mod 1000)
''    Debug.Print "fr="; (Fraction((Fraction(u) * 10000#) * 1000#) * 1000)
''    Debug.Print "msecs="; ((Fraction((Fraction(u) * 10000#) * 1000#) * 1000) Mod 1000)
'''    Debug.Print "VBDate(d)="; VBDate(d)
''    '((x-(int x) * 10) mod 1000) -> 437ms
''    Debug.Print "PHPDatenow(d)="; PHPDateNow(d)   '!!!
''    Debug.Print "PHPDate(d)="; vbStr(PHPDate(d))
''    Debug.Print "PHPDate(d)="; vbStr(PHPDate(d, "r"))
''    Debug.Print "PHPDate(d)="; vbStr(PHPDate(d, "c"))
'End
'End Sub
'
''This test-function is not publicly-used and can be commented-out or removed and replaced with a "null" stub to save space
''Public Function NetErrorMsg(ByVal ErrorNumber As Long)
''    NetErrorMsg = ""
''End Function
'
'Public Function NetErrorMsg(ByVal ErrorNumber As Long)
'    Select Case ErrorNumber
'        Case 0
'            NetErrorMsg = "No error"
'        Case 85
'            NetErrorMsg = "Device already assigned"
'        Case 86
'            NetErrorMsg = "Invalid password"
'        Case 113
'            NetErrorMsg = "Out of search handles"
'        Case 170
'            NetErrorMsg = "System is busy"
'        Case 1130
'            NetErrorMsg = "Not enough server storage available - try increasing server's IRPStackSize or PagedPoolSize"
'        Case 1909
'            NetErrorMsg = "User is locked-out"
'        Case 1200
'            NetErrorMsg = "Bad device specified"
'        Case 1201
'            NetErrorMsg = "Out of connections"
'        Case 1202
'            NetErrorMsg = "Device already remembered"
'        Case 1203
'            NetErrorMsg = "No net or bad path"
'        Case 1206
'            NetErrorMsg = "Bad profile"
'        Case 1208
'            NetErrorMsg = "Extended error"
'        Case 1210
'            NetErrorMsg = "Bad computer name"
'        Case 1214
'            NetErrorMsg = "Bad net name"
'        Case 1219
'            NetErrorMsg = "Session credential conflict"
'        Case 1223
'            NetErrorMsg = "User cancelled"
'        Case 1326
'            NetErrorMsg = "Invalid login credentials"
'        Case 2202
'            NetErrorMsg = "Bad username"
'        Case 2250
'            NetErrorMsg = "Not connected"
'        Case 2401
'            NetErrorMsg = "Open files on this connection"
'        Case 2404
'            NetErrorMsg = "Device is currently in use"
'        Case 2999
'            NetErrorMsg = "No more drive letters available"
'        Case Else
'            NetErrorMsg = "Unhandled error - " & Format$(ErrorNumber)
'    End Select
'End Function
Public Sub test()
    Dim a As String
    Dim b As String
    Dim l As Long
    a = "The quick brown foxx jumped over        the lazy doggggggggggggggggg"
    Debug.Print "Source Len(a)="; Len(a)
    b = RLECompress(a, Len(a))
    Debug.Print "RLE Compressible? "; RLECompressible(a)
    Debug.Print "CompressedByteCount=["; RLECompressedByteCount(a, Len(a)); "]"
    If RLECompressedByteCount(a, Len(a)) >= Len(a) Then
        Debug.Print "No compression gain possible"
    Else
        Debug.Print "Compression gain of "; Len(a) - RLECompressedByteCount(a, Len(a)); " byte(s)"
    End If
    Debug.Print "compressed string is ["; b; "]"
    Debug.Print "UncompressedByteCount=["; RLEUncompressedByteCount(b); "]"
    Debug.Print "Uncompressed string is ; ["; RLEUncompress(b); "] "
    Debug.Print "Uncompressed string length is "; Len(RLEUncompress(b))
    Debug.Print "ByteCount=["; RLEByteCount(b); "]"
    
End Sub
